#### 下载  erlang

https://www.erlang.org/patches/otp-22.3.4.26

### 安装erlang

检查依赖

```
rpm -qa | grep -E "ncurses-devel*|openssl-devel*"
```

安装依赖（root）

```
yum install ncurses-devel 
yum install openssl-devel

```

配置安装目录

```
cd /app/otp_src_25.3/
./configure --prefix=/home/test02/erlang/
```

编译安装

```
make && make install
```



编辑path

```
cd ~
vi .bash_profile

追加
export PATH=$PATH:/home/test02/erlang/bin

刷新
source .bash_profile
```





验证

```
erl


#退出
halt()
.
```



### 安装rabbitmq

https://www.rabbitmq.com/download.html





https://github.com/rabbitmq/rabbitmq-server/releases/download/v3.10.6/rabbitmq-server-generic-unix-3.10.6.tar.xz



erlang rabbitma 版本对应关系

https://www.rabbitmq.com/which-erlang.html

解压rabbitmq

```
xz -d /home/test02/rabbitmq/rabbitmq-server-generic-unix-3.8.3.tar.xz
tar xvf /home/test02/rabbitmq/rabbitmq-server-generic-unix-3.8.3.tar

```



配置rabbitmq

```
cd /home/test02/rabbitmq/rabbitmq_server-3.8.3/etc/rabbitmq/
vim rabbitmq.env.conf


#添加内容如下：
#node name
NODENAME=rabbit

#data dir
MNESIA_BASE=/home/test02/rabbitmq/rabbitmq/data


端口设置
vim rabbitmq.conf

#添加内容如下：
#listen port
listeners.tcp.default = 5672

#log dir
log.dir =/home/test02/rabbitmq/rabbitmq/logs

#open remote request
loopback_users = none

```

手动创建目录

```
mkdir /home/test02/rabbitmq/rabbitmq/data /home/test02/rabbitmq/rabbitmq/logs -p
```



配置 path

```
vim .bash_profile
#添加内容如下：
# rabbitmq
export PATH=$PATH:/home/test02/rabbitmq/rabbitmq/sbin


#刷新
source .bash_profile 
```







启动rabbitmq 

```
rabbitmq-server  -detached
```



启动状态

```
rabbitmqctl status
```

停止 

```
rabbitmqctl stop
```



```

```

启动控制台插件

```
rabbitmq-plugins enable rabbitmq_management
```





创建新用户

默认用户guest只能localhost本地登录

所以新建用户 供后续使用

```

rabbitmqctl add_user yiling yiling123456;a
rabbitmqctl set_user_tags yiling administrator
rabbitmqctl set_permissions -p / yiling  ".*" ".*" ".*"
```



修改guest 弱口令

![image-20220815105935659](http://pic.61dz.com/pic/image-20220815105935659.png)

![image-20220815110022686](http://pic.61dz.com/pic/image-20220815110022686.png)



访问控制台

ip:15672

用刚刚创建的账号（yiling）密码（yiling123456;a）登录。



![image-20220815102950262](http://pic.61dz.com/pic/image-20220815102950262.png)













### 回退

卸载依赖

yum remove ncurses-devel 
yum remove openssl-develremove 



删除 erlang

rm -rf /home/test02/erlang

删除rabbitmq

rm -rf /home/test02/rabbitmq



修改path

cd ~

vi .bash_profile

将之前追加的 path  路径删除
export PATH=$PATH:/home/test02/erlang/bin

刷新
source .bash_profile